// MainFrame.cpp
#include "MainFrame.h"

#define IDC_BTN_INICIAR		300
#define IDC_BTN_ADICIONAR	301
#define IDC_LBN_UNIVER		302
#define IDC_LBN_DEPART		303

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_BN_CLICKED(IDC_BTN_INICIAR, OnClickBtnIniciar)
	ON_BN_CLICKED(IDC_BTN_ADICIONAR, OnClickBtnAdicionar)
	ON_LBN_SELCHANGE(IDC_LBN_UNIVER, OnChangeLtUniver)
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
	init();

	frmAdiciona = NULL;
	objeto_principal = new Principal();	
}

CMainFrame::~CMainFrame()
{
	delete objeto_principal;
}

void CMainFrame::init()
{
	Create(NULL, "ProjetoOOJanelaExemplo", WS_OVERLAPPEDWINDOW,
		CRect(CPoint(50, 50), CSize(500, 300)));

	lbUniver.Create("Lista de Universidades", WS_VISIBLE | WS_CHILD,
		CRect(CPoint(50, 25), CSize(180, 20)), this);

	lbDepart.Create("Lista de Departamentos", WS_VISIBLE | WS_CHILD,
		CRect(CPoint(250, 25), CSize(180, 20)), this);
	
	btnIniciar.Create("Iniciar", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(50, 200), CSize(100, 30)), this, IDC_BTN_INICIAR);

	btnAdicionar.Create("Adicionar", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
		CRect(CPoint(180, 200), CSize(100, 30)), this, IDC_BTN_ADICIONAR);

	ltUniver.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | LBS_STANDARD,
		CRect(CPoint(50,50), CSize(180, 130)), this, IDC_LBN_UNIVER);

	ltDepart.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | LBS_STANDARD,
		CRect(CPoint(250,50), CSize(180, 130)), this, IDC_LBN_DEPART);
}

void CMainFrame::OnClickBtnIniciar()
{
	while ( ltUniver.GetCount() > 0 )
		ltUniver.DeleteString( 0 );

	objeto_principal->IteradorLUniversidades = objeto_principal->LUniversidades.begin();

	while (objeto_principal->IteradorLUniversidades!= objeto_principal->LUniversidades.end())
	{
		string aux;
		aux = (*(objeto_principal->IteradorLUniversidades))->getNome();

		ltUniver.AddString( aux.data() );
		objeto_principal->IteradorLUniversidades++;
	}
}

void CMainFrame::OnClickBtnAdicionar()
{
	if (frmAdiciona == NULL || !IsWindow( *frmAdiciona ))
	{
		frmAdiciona = new frmAdicionaUniver(objeto_principal);
	}

	frmAdiciona->ShowWindow( SW_SHOW );
	frmAdiciona->BringWindowToTop();
}

void CMainFrame::OnChangeLtUniver()
{
	while (ltDepart.GetCount() > 0)
		ltDepart.DeleteString( 0 );

	CString NomeUniv;
	
	ltUniver.GetText(ltUniver.GetCurSel(), NomeUniv);	// utiliza uma referncia para capturar a string;
	
	Universidade* pUniv = NULL;
	
	objeto_principal->IteradorLUniversidades = objeto_principal->LUniversidades.begin();
	while (objeto_principal->IteradorLUniversidades!= objeto_principal->LUniversidades.end())
	{
		string aux;
		aux = (*(objeto_principal->IteradorLUniversidades))->getNome();
		CString NomeAux = aux.data();
		
		if ( NomeUniv == NomeAux )
		{
			pUniv = *(objeto_principal->IteradorLUniversidades);
			break;
		}
		
		objeto_principal->IteradorLUniversidades++;
	}
	
	if (pUniv)
	{
		int tam = (int)	pUniv->ObjLDepartamentos.size();
		
		for (int i = 0; i < tam; i++)
		{
			Departamento* pDepart = NULL;
			pDepart = pUniv->ObjLDepartamentos[ i ];
			
			const string aux = pDepart->getNome();
			CString linha = aux.data();
			ltDepart.AddString( linha );
		}		
	}
}